/* 
 * Compile with: 
 * cc -I/usr/local/include -o event-test event-test.c -L/usr/local/lib -levent 
 */ 

#include <sys/types.h> 
#include <sys/stat.h> 
#ifndef WIN32 
#include <sys/queue.h> 
#include <unistd.h> 
#include <sys/time.h> 
#else 
#pragma comment(lib, "ws2_32.lib") 
#include <winsock2.h> 
#include <windows.h> 
#endif 
#include <fcntl.h> 
#include <stdlib.h> 
#include <stdio.h> 
#include <string.h> 
#include <errno.h> 

#include <event.h> 

void 
evAccept(int fd, short event, void* arg) 
{ 
  fprintf(stderr, "뷫 ο \n"); 
} 

int main(void) 
{ 
  WSADATA data; 
  int sock; 
  struct sockaddr_in sa; 
  struct event ev; 

  WSAStartup(MAKEWORD(2,2), &data); 

  sock = socket(AF_INET, SOCK_STREAM, 0); 
  if (sock==-1) 
  { 
    fprintf(stderr, "  \n"); 
    return 0; 
  } 

  memset(&sa, 0x00, sizeof(sa)); 
  sa.sin_family = AF_INET; 
  sa.sin_port = htons(9999); 

  if ( -1 == bind(sock, (struct sockaddr*)&sa, sizeof(sa)) ) 
  { 
    fprintf(stderr, " ε \n"); 
    return 0; 
  } 

  if ( -1 == listen(sock, 15) ) 
  { 
    fprintf(stderr, "  \n"); 
    return 0; 
  } 

  event_init(); 
  event_set(&ev, sock, EV_TIMEOUT|EV_WRITE|EV_READ|EV_PERSIST, evAccept, &ev); 
  if ( event_add(&ev, NULL) ) 
  { 
    fprintf(stderr, "̺Ʈ ߰ \n"); 
    return 0; 
  } 

  event_dispatch(); 

  return 0; 
}